# Reporting Bugs

NSClient++ is a mature monitoring agent which has established a reputation for stability.
In order to maintain this reputation, the developers would like to know of any deficiencies you find in NSClient++.

## Documentation bugs

If you find a bug in this documentation or would like to propose an improvement,
please send an e-mail to docs@nsclient.org describing the bug and where you found
Of course, if you have a suggestion how to fix it, include that as well.

docs@nsclient.org is a mailing address run by volunteers; your request will be
noticed, even if it takes a while to be processed.

Of course, if you want a more persistent record of your issue, you can use the
issue tracker for documentation bugs as well.

## Using the NSClient++ issue tracker

Bug reports for NSClient++ itself should be submitted via the NSClient++ Bug Tracker on github [here](https://github.com/mickem/nscp/issues).
The bug tracker offers a Web form
which allows pertinent information to be entered and submitted to the developers.

The first step in filing a report is to determine whether the problem has
already been reported.  The advantage in doing so, aside from saving the
developers time, is that you learn what has been done to fix it; it may be that
the problem has already been fixed for the next release, or additional
information is needed (in which case you are welcome to provide it if you can!).
To do this, search the bug database using the search box on the top of the page.

If the problem you're reporting is not already in the bug tracker, go back to
the NSClient++ Bug Tracker and log in.  If you don't already have a github account,
select the "Register" link. It is not possible to submit a bug report anonymously.

Being now logged in, you can submit a bug.  Select the "New Bug" link to open the
bug reporting form.

The submission form has a number of fields.  For the "Title" field, enter a
*very* short description of the problem; less than ten words is good.

In the "Comment" field, describe the problem in detail, including what you
expected to happen and what did happen.  Be sure to include whether any
extension modules were involved, and what hardware and software platform you
were using (including version information as appropriate).

Each bug report will be assigned to a developer who will determine what needs to
be done to correct the problem.  You will receive an update each time action is
taken on the bug.

*   [How to Report Bugs Effectively](http://www.chiark.greenend.org.uk/~sgtatham/bugs.html)
*   [Bug Writing Guidelines](http://developer.mozilla.org/en/docs/Bug_writing_guidelines)
